package com.lc.day11.test2;

/**
 * ClassName: ConsumerProducerTest
 * Package: com.lc.day11.test2
 * Description:
 *
 * @Author 爱扣钉-陈晨
 * @Create 2023/7/27 20:41
 * @Version 1.0
 */
public class ConsumerProducerTest {
    public static void main(String[] args) {
        Product product = new Product();
        Producer p1 = new Producer(product);

       Consumer c1 = new Consumer(product);
        Consumer c2 = new Consumer(product);

        p1.setName("生产者1");
        c1.setName("消费者1");
        c2.setName("消费者2");

        p1.start();
        c1.start();
        c2.start();
    }
}

//生产者
class Producer extends Thread{
    private Product product;

    public Producer(Product product){
        this.product = product;
    }

    @Override
    public void run() {

        System.out.println("=========生产者开始生产产品========");
        while(true){

            try {
                Thread.sleep(40);
            } catch (InterruptedException e) {
                e.printStackTrace();
            }

            //要求Product去增加产品
            product.addProduct();
        }
    }
}

//消费者
class Consumer extends Thread{
    private Product product;

    public Consumer(Product product){
        this.product = product;
    }
    @Override
    public void run() {
        System.out.println("=========消费者开始消费产品========");
        while(true){

            try {
                Thread.sleep(90);
            } catch (InterruptedException e) {
                e.printStackTrace();
            }

            //要求Product去减少产品
            product.minusProduct();
        }
    }
}

//资源类
class Product {
    private int productNum = 0;//产品数量
    private static final int MAX_PRODUCT = 20;
    private static final int MIN_PRODUCT = 1;

    //增加产品
    public synchronized void addProduct() {
        if(productNum < MAX_PRODUCT){
            productNum++;
            System.out.println(Thread.currentThread().getName() +
                    "生产了第" + productNum + "个产品");
            //唤醒消费者
            this.notifyAll();
        }else{

            try {
                this.wait();
            } catch (InterruptedException e) {
                e.printStackTrace();
            }
        }
    }

    //减少产品
    public synchronized void minusProduct() {
        if(productNum >= MIN_PRODUCT){
            System.out.println(Thread.currentThread().getName() +
                    "消费了第" + productNum + "个产品");
            productNum--;

            //唤醒生产者
            this.notifyAll();
        }else{
            try {
                this.wait();
            } catch (InterruptedException e) {
                e.printStackTrace();
            }
        }
    }

}