package com.lc.day11.test5;

import java.util.Calendar;
import java.util.Scanner;

/**
 * ClassName: CalendarTest
 * Package: com.lc.day11.test5
 * Description:
 *
 * @Author 爱扣钉-陈晨
 * @Create 2023/7/28 8:10
 * @Version 1.0
 */
public class CalendarTest {
    private static Scanner scanner = new Scanner(System.in);
    private static int year;
    private static int month;
    private static final int[] MONTHS =
            {31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31};//月份天数数组

    public static void main(String[] args) {
        getValue();
        showCalendar(year, month);
    }

    private static void getValue() {
        System.out.print("请输入年份:");
        year = scanner.nextInt();
        while (year > 3000 || year < 1900) {
            System.out.println("年份有误,请重新输入：");
            year = scanner.nextInt();
        }
        if (isLeap(year)) {//是闰年2月变为29天
            MONTHS[1] = 29;
        }
        System.out.print("请输入月份:");
        month = scanner.nextInt();
        while (month > 12 || year < 0) {
            System.out.println("月份有误,请重新输入：");
            year = scanner.nextInt();
        }
        scanner.close();
    }

    private static void showCalendar(int year, int month) {
        int count = 0;//计数器，用于记录每行数据个数
        int monthIndex = month - 1;//真实月份-1得下标
        System.out.println("日" + "\t" + "一" + "\t" + "二" + "\t" + "三" + "\t" +
                "四" + "\t" + "五" + "\t" + "六" + "\t");
        Calendar calendar = Calendar.getInstance();
        calendar.set(Calendar.YEAR, year);//设置年
        calendar.set(Calendar.MONTH, monthIndex);//设置月
        calendar.set(Calendar.DAY_OF_MONTH, 1);//设置为月份的1号
        int dayOfWeek = calendar.get(Calendar.DAY_OF_WEEK);
        //1号为星期几，注意星期日是1，星期六是7
        for (int i = 0; i < dayOfWeek - 1; i++) {//打印第一行
            System.out.print("\t");
            count++;
        }
        for (int i = 1; i <= MONTHS[monthIndex]; i++) {
            System.out.print(i);
            count++;
            if (count == 7) {//满7换行
                System.out.println();
                count = 0;
                continue;
            }
            System.out.print("\t");
        }
    }

    private static boolean isLeap(int year) {

        if (year % 4 == 0 && year % 100 != 0 || year % 400 == 0) {
            return true;
        } else {
            return false;
        }
    }
}