package com.lc.day11.thread5;

/**
 * ClassName: HungrySingle
 * Package: com.lc.day11.thread5
 * Description:
 *
 * @Author 爱扣钉-陈晨
 * @Create 2023/7/27 16:39
 * @Version 1.0
 */
public class HungrySingle {

    private static HungrySingle INSTANCE = new HungrySingle();
    //对象是否声明为final 都可以

    private HungrySingle(){}

    public static HungrySingle getInstance(){
        return INSTANCE;
    }


    static HungrySingle instance1;
    static HungrySingle instance2;

    public static void main(String[] args) {

        Thread thread1 = new Thread() {
            @Override
            public void run() {
                instance1 = HungrySingle.INSTANCE;
            }
        };

        Thread thread2 = new Thread() {
            @Override
            public void run() {
                instance2 = HungrySingle.INSTANCE;
            }
        };

        try {
            thread1.join();
            thread2.join();
            thread1.start();
            thread2.start();
        } catch (InterruptedException e) {
            throw new RuntimeException(e);
        }

        System.out.println(instance1 == instance2);
    }
}
