package com.lc.day11.thread5;

/**
 * ClassName: LazyOne
 * Package: com.lc.day11.thread5
 * Description:
 *
 * @Author 爱扣钉-陈晨
 * @Create 2023/7/27 16:43
 * @Version 1.0
 */
public class LazyOne {

    private static LazyOne instance;

    LazyOne(){}

    //方式1：
    public static synchronized LazyOne getInstance1(){
        if(instance == null){
//            try {
//                Thread.sleep(10);
//            } catch (InterruptedException e) {
//                throw new RuntimeException(e);
//            }
            instance = new LazyOne();
        }
        return instance;
    }

    //方式2：
    public static LazyOne getInstance2(){
        synchronized (LazyOne.class){
            if(instance == null){
                instance = new LazyOne();
            }
        }
        return instance;
    }

    //方式3：双重验证
    public static LazyOne getInstance3(){
        if(instance == null){
            synchronized (LazyOne.class){
                if(instance == null){
                    instance = new LazyOne();
                }
            }
        }

        return instance;
    }

}
