package com.lc.day12.string5;

import org.junit.Test;

import java.io.UnsupportedEncodingException;
import java.util.Arrays;

/**
 * ClassName: TestString
 * Package: com.lc.day12.string5
 * Description:
 *
 * @Author 爱扣钉-陈晨
 * @Create 2023/7/28 15:48
 * @Version 1.0
 */
public class TestString {

    /*
    （16）String substring(int beginIndex) ：返回一个新的字符串，它是此字符串的从beginIndex开始截取到最后的一个子字符串。
    （17）String substring(int beginIndex, int endIndex) ：返回一个新字符串，它是此字符串从beginIndex开始截取到endIndex(不包含)的一个子字符串。
     */
    @Test
    public void test04(){
        String str = "从前往后找当前字符串中xx，如果有";
        String substring = str.substring(1);
        System.out.println(substring);

        String substring1 = str.substring(str.length() - 3);
        System.out.println(substring1);

        int i = str.indexOf("当前");
        System.out.println(i);
        String substring2 = str.substring(i, i + 2);
        System.out.println(substring2);

    }

    /*
    （11）boolean contains(xx)：是否包含xx
    （12）int indexOf(xx)：从前往后找当前字符串中xx，即如果有返回第一次出现的下标，要是没有返回-1
    （13）int indexOf(String str, int fromIndex)：返回指定子字符串在此字符串中第一次出现处的索引，从指定的索引开始
    （14）int lastIndexOf(xx)：从后往前找当前字符串中xx，即如果有返回最后一次出现的下标，要是没有返回-1
    （15）int lastIndexOf(String str, int fromIndex)：返回指定子字符串在此字符串中最后一次出现处的索引，从指定的索引开始反向搜索。
     */
    @Test
    public void test03(){
        String str = "爱扣钉是一家靠谱的培训机构，爱扣钉可以说是IT培训的好地方，JavaEE是爱扣钉的当家学科，爱扣钉的前端和UI专业一样独领风骚。";

        boolean b = str.contains("爱扣钉hahah");
        System.out.println(b);

        int i = str.indexOf("培训");
        System.out.println(i);


        int i1 = str.lastIndexOf("JavaEE111");
        System.out.println(i1);

    }

    /*
    ### 常用方法

    （1）boolean isEmpty()：字符串是否为空
    （2）int length()：返回字符串的长度
    （3）String concat(xx)：拼接
    （4）boolean equals(Object obj)：比较字符串是否相等，区分大小写
    （5）boolean equalsIgnoreCase(Object obj)：比较字符串是否相等，不区分大小写
    （6）int compareTo(String other)：比较字符串大小，区分大小写，按照Unicode编码值比较大小
    （7）int compareToIgnoreCase(String other)：比较字符串大小，不区分大小写
    （8）String toLowerCase()：将字符串中大写字母转为小写
    （9）String toUpperCase()：将字符串中小写字母转为大写
    （10）String trim()：去掉字符串前后空白符
    （11）public String intern()：结果在常量池中共享
     */

    @Test
    public void test02(){
        String str = "";
        boolean empty = str.isEmpty();
        System.out.println(empty);

        str= "hello";
        System.out.println(str.length());

        String concat = str.concat("world");
        System.out.println(concat);

        System.out.println(str.equals("hello"));

        String a = "c";
        int i = a.compareTo("a");  //排序
        System.out.println(i);
        //0 相等  证书  大于   小于

        String s1 = "  hello ";
        System.out.println(s1);
        String trim = s1.trim();
        System.out.println(trim);
    }

    /*
     * `public String(char[] value) ` ：通过当前参数中的字符数组来构造新的String。
     * `public String(char[] value,int offset, int count) ` ：通过字符数组的一部分来构造新的String。
     * `public String(byte[] bytes) ` ：通过使用平台的**默认字符集**解码当前参数中的字节数组来构造新的String。
     * `public String(byte[] bytes,String charsetName) ` ：通过使用指定的字符集解码当前参数中的字节数组来构造新的String。
     */
    @Test
    public void test01() throws UnsupportedEncodingException {
        char[] arr = {'h','e','l','l','o'};

        String s = new String(arr);
        System.out.println(s);

        String s1 = new String(arr,0,3);
        System.out.println(s1);

        byte[] bytes = {97,98,99};
        byte[] zhong = {-28, -72, -83};

        String s2 = new String(bytes);
        System.out.println(s2);

        String s3 = new String(zhong);
        System.out.println(s3);

        byte[] bytes1 = "中".getBytes("GBK");

        System.out.println(Arrays.toString(bytes1));

        byte[] bytes2 = {-42, -48};
        String s4 = new String(bytes2,"GBK");
        System.out.println(s4);

    }
}
